

//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
//_/_/
//_/_/  This file is part of CMSDK version 2.0.2.180713 (13 July 2018)
//_/_/  
//_/_/  developed by
//_/_/  
//_/_/  Communicative Machines Ltd. 
//_/_/    http://cmlabs.com/
//_/_/  Copyright (c) 2018
//_/_/  
//_/_/  in collaboration with 
//_/_/  
//_/_/  Icelandic Institute for Intelligent Machines ses
//_/_/    Menntavegur 1
//_/_/    101 Reykjavik
//_/_/    ICELAND
//_/_/    http://www.iiim.is/
//_/_/
//_/_/  and is released under the following
//_/_/  
//_/_/  EXTENDED BSD License
//_/_/
//_/_/  Redistribution and use in source and binary forms, with or without
//_/_/  modification, is permitted provided that the following conditions 
//_/_/  are met:
//_/_/
//_/_/  - Redistributions of source code must retain the above copyright 
//_/_/    and collaboration notice, this list of conditions and the following 
//_/_/    disclaimer.
//_/_/
//_/_/  - Redistributions in binary form must reproduce the above copyright 
//_/_/    notice, this list of conditions and the following disclaimer in the 
//_/_/    documentation and/or other materials provided with the distribution.
//_/_/
//_/_/  - Neither the name of its copyright holders nor the names of its 
//_/_/    contributors may be used to endorse or promote products derived from 
//_/_/    this software without specific prior written permission.
//_/_/
//_/_/  - CADIA Clause: The license granted in and to the software under this 
//_/_/    agreement is a limited-use license. The software may not be used in 
//_/_/    furtherance of: (i) intentionally causing bodily injury or severe 
//_/_/    emotional harm to any person; (ii) invading the personal privacy or 
//_/_/    violating the human rights of any person; or (iii) committing or 
//_/_/    preparing for any act of war. 
//_/_/
//_/_/  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
//_/_/  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
//_/_/  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
//_/_/  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER 
//_/_/  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
//_/_/  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
//_/_/  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
//_/_/  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
//_/_/  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
//_/_/  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
//_/_/  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//_/_/
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#if !defined(_MEMORYREQUESTCONNECTION_H_)
#define _MEMORYREQUESTCONNECTION_H_

#include "MemoryRequestQueues.h"

namespace cmlabs {

#define MEMORYREQUESTSERVER_INIT	1


struct RequestServerHeader {
	uint32 size;
	uint32 cid;
	uint64 createdTime;
	uint64 lastUpdateTime;
	char name[256];
	uint16 status;
	uint32 maxConnectionCount;
	uint32 eachConnectionSize;
	uint32 maxQueueSize;
	uint32 maxRequestCount;
};

struct RequestConnectionHeader {
	uint32 size;
	uint32 conid;
	uint64 createdTime;
	uint64 lastUpdateTime;
	uint16 status;
};

class MemoryRequestConnection {
public:
	MemoryRequestConnection();
	~MemoryRequestConnection();

	bool connect(const char* memoryName);
	bool shutdown();

	uint64 makeRequest(DataMessage* msg);
	uint16 getRequestStatus(uint64 id, uint64& createdTime, uint64& lastUpdateTime);
	DataMessage* waitForRequestReply(uint32 ms);

	DataMessage* waitForRequestReply(uint64 id, uint32 ms);

	DataMessage* waitForRequest(uint32 ms);
	bool setRequestStatus(uint64 id, uint16 status);
	bool replyToRequest(uint64 id, DataMessage* msg);

private:
	RequestServerHeader* serverHeader;
	RequestConnectionHeader* conHeader;
	char* queueHeader;
	char* requestHeader;

	std::map<uint64, DataMessage*> replyCache;

	uint32 conID;
	bool oneWaitingForQueue;
	
	utils::Mutex* mutex;
	utils::Event cacheEvent;

	char* getQueueHeader(uint32 otherConID);
	DataMessage* waitForQueue(uint32 ms);
};

} // namespace cmlabs

#endif //_MEMORYREQUESTCONNECTION_H_

